#auto_version

#import <shaders/include/instanced.glsl>
#import <shaders/include/rect_offsets.glsl>
#import <shaders/include/text.glsl>

// instance attributes
in vec2 Position;
in float Size;
in vec4 Color;
in uint Char;
in uint Flags;
in ivec2 UVBase;
/**
 * In pixels.
 */
in ivec2 UVExtent;

/* IIUC, the spec says that it is not required to duplicate the `centroid` modifier here. But apparently Windows
   requires it. */
out vec2 vUV;
out float vLocalV;
out vec4 vColor;
flat out float vBold;
flat out float vStrike;
flat out float vUnderline;

void main() {
    vec2 offset = Offset;
    vec2 localPosition = offset;
    if (bool(Flags & FLAG_ITALIC)) {
        localPosition -= vec2(offset.y / 4.0, 0.0);
    }
    vec2 pos = fma(localPosition, vec2(Size), Position);
    gl_Position = projectPos(pos);

    applyClip(pos);

    uint ui = Char & uint(15);
    uint vi = Char >> uint(4);
    // the extent of each glyph texture in the atlas on a scale of [0.0, 1.0]
    vec2 atlasExtent = vec2(UVExtent) / float(#atlas_size);
    vUV = vec2(ui, vi) * atlasExtent;
    vUV += fma(offset, atlasExtent - SUPER_PIXEL, vec2(SUPER_PIXEL / 2.0));
    vLocalV = mod(vUV.y / (SUPER_PIXEL * float(UVExtent.y)), 1.0);
    vUV += UVBase / 256.0;
    vColor = Color;
    vBold = float(bool(Flags & FLAG_BOLD));
    vStrike = float(bool(Flags & FLAG_STRIKE));
    vUnderline = float(bool(Flags & FLAG_UNDERLINE));
}
